package com.huimv.admin.timer;


import cn.hutool.core.codec.Base64;
import cn.hutool.core.date.DateTime;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.huimv.admin.common.utils.Digests;
import com.huimv.admin.common.utils.HttpClientSSLUtils;
import com.huimv.admin.entity.*;
import com.huimv.admin.entity.zengxindto.*;
import com.huimv.admin.service.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Configuration;
import org.springframework.http.*;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.client.RestTemplate;

import java.time.LocalDate;
import java.util.*;

@Configuration
@EnableScheduling
public class ShenChanTimer {

    //生产数据
    @Autowired
    private RestTemplate restTemplate;
    @Autowired
    private IProdStockService prodStockService;


//    @Scheduled(cron = "0 0/11 * * * ? ")
    @Scheduled(cron = "0 1 */1 * * ?")
    private void getShenChan() throws Exception {
        Integer farmId = 21;
        String time = LocalDate.now().toString();
        String token = login();
        System.out.println("token"+token);
        ProdStock prodStock = prodStockService.getOne(new QueryWrapper<ProdStock>().eq("farm_id", farmId).orderByDesc("creat_time").last("limit 1"));

        System.out.println(token);

        String url = "http://test.htpig.cn/rest/db/storedproc";
        Map<String, Object> map = new HashMap<String, Object>();
        map.put("db_name","MSSQL");
        map.put("proc_name","rep_yz_kc_hz");
        map.put("method","open_proc");
        HashMap<String, Object> maps = new HashMap<>();
        List list = new ArrayList();
        maps.put("name","@fdate");
        maps.put("value",time);
        list.add(maps);

        map.put("params",list);
        String params = JSON.toJSONString(map);
        System.out.println(" ====== getStock请求参数：【" + params + "】");
        String data = HttpClientSSLUtils.doPost(url+"?token="+token+"&data=", params);
        ProdStockDto prodStockDto = JSONUtil.toBean(data, ProdStockDto.class);
        List<List<Object>> stockData = prodStockDto.getData();
        System.out.println(prodStockDto.toString());
        for (List stock : stockData) {
            if ("正康".equals(stock.get(0))){
                prodStock.setZzcl(Integer.parseInt(stock.get(11).toString()));
                prodStock.setByzcl(Integer.parseInt(stock.get(13).toString()));
                prodStock.setYfzcl(Integer.parseInt(stock.get(14).toString()));
                prodStock.setZcl(Integer.parseInt(stock.get(15).toString()));
                prodStockService.updateById(prodStock);
            }
        }

    }


    private String login() throws Exception {
        StockLoginDto stockLoginDto = restTemplate.getForObject("http://test.htpig.cn/rest/user/login?user_name=test&password=e10adc3949ba59abbe56e057f20f883e&db_name=MSSQL", StockLoginDto.class);
        if (stockLoginDto.getStatus() != 0){
            return null;
        }
        return stockLoginDto.getToken();
    }

}
